
#pragma once

#include "7zip/Archive/IArchive.h"

class CExtractCallback :
	public IArchiveExtractCallback,
	public CMyUnknownImp
{
public:
	MY_UNKNOWN_IMP

	// IProgress
	STDMETHOD(SetTotal)(UInt64 size);
	STDMETHOD(SetCompleted)(const UInt64 *completeValue);

	// IArchiveExtractCallback
	STDMETHOD(GetStream)(UInt32 index, ISequentialOutStream **outStream, Int32 askExtractMode);
	STDMETHOD(PrepareOperation)(Int32 askExtractMode);
	STDMETHOD(SetOperationResult)(Int32 resultEOperationResult);

private:
	CMyComPtr<IInArchive> archive_;
	UInt64 totalSize_;

public:
	CMyComPtr<ISequentialOutStream> OutStream_;
	Int32 Result_;

	LPVOID ExtractCallbackParam_;
	ArchiveExtractCallback ExtractCallback_;

public:
	CExtractCallback();
	void Init(IInArchive *archive);
};

